summaryrefslogtreecommitdiff
path: root/eclass
diff options
context:
space:
mode:
authorV3n3RiX <venerix@redcorelinux.org>2020-09-30 17:27:54 +0100
committerV3n3RiX <venerix@redcorelinux.org>2020-09-30 17:27:54 +0100
commitf70a1bfc721336d4fc7dfb711c2f518a6b18cf16 (patch)
treee907cb121b30e3c1df1710719c0ddf4029597a47 /eclass
parentdb063b515939ab15261136b24e4bc44386335c0c (diff)
gentoo resync : 30.09.2020
Diffstat (limited to 'eclass')
-rw-r--r--eclass/Manifest.gzbin36592 -> 36266 bytes
-rw-r--r--eclass/cargo.eclass177
-rw-r--r--eclass/cmake.eclass106
-rw-r--r--eclass/elisp-common.eclass9
-rw-r--r--eclass/mozconfig-v6.52.eclass391
-rw-r--r--eclass/mozcoreconf-v4.eclass261
6 files changed, 200 insertions, 744 deletions
diff --git a/eclass/Manifest.gz b/eclass/Manifest.gz
index 4922289c95f3..422760e8457d 100644
--- a/eclass/Manifest.gz
+++ b/eclass/Manifest.gz
Binary files differ
diff --git a/eclass/cargo.eclass b/eclass/cargo.eclass
index 6d341601a112..e6fec844d274 100644
--- a/eclass/cargo.eclass
+++ b/eclass/cargo.eclass
@@ -46,6 +46,35 @@ ECARGO_VENDOR="${ECARGO_HOME}/gentoo"
# }
# @CODE
+# @ECLASS-VARIABLE: ECARGO_REGISTRY_DIR
+# @USER_VARIABLE
+# @DEFAULT_UNSET
+# @DESCRIPTION:
+# Storage directory for cargo registry.
+# Used by cargo_live_src_unpack to cache downloads.
+# This is intended to be set by users.
+# Ebuilds must not set it.
+#
+# Defaults to "${DISTDIR}/cargo-registry" it not set.
+
+# @ECLASS-VARIABLE: ECARGO_OFFLINE
+# @USER_VARIABLE
+# @DEFAULT_UNSET
+# @DESCRIPTION:
+# If non-empty, this variable prevents online operations in
+# cargo_live_src_unpack.
+# Inherits value of EVCS_OFFLINE if not set explicitly.
+
+# @ECLASS-VARIABLE: EVCS_UMASK
+# @USER_VARIABLE
+# @DEFAULT_UNSET
+# @DESCRIPTION:
+# Set this variable to a custom umask. This is intended to be set by
+# users. By setting this to something like 002, it can make life easier
+# for people who use cargo in a home directory, but are in the portage
+# group, and then switch over to building with FEATURES=userpriv.
+# Or vice-versa.
+
# @FUNCTION: cargo_crate_uris
# @DESCRIPTION:
# Generates the URIs to put in SRC_URI to help fetch dependencies.
@@ -62,6 +91,44 @@ cargo_crate_uris() {
done
}
+# @FUNCTION: cargo_gen_config
+# @DESCRIPTION:
+# Generate the $CARGO_HOME/config necessary to use our local registry and settings.
+# Cargo can also be configured through environment variables in addition to the TOML syntax below.
+# For each configuration key below of the form foo.bar the environment variable CARGO_FOO_BAR
+# can also be used to define the value.
+# Environment variables will take precedent over TOML configuration,
+# and currently only integer, boolean, and string keys are supported.
+# For example the build.jobs key can also be defined by CARGO_BUILD_JOBS.
+# Or setting CARGO_TERM_VERBOSE=false in make.conf will make build quieter.
+cargo_gen_config() {
+ debug-print-function ${FUNCNAME} "$@"
+
+ mkdir -p "${ECARGO_HOME}" || die
+
+ cat > "${ECARGO_HOME}/config" <<- _EOF_ || die "Failed to create cargo config"
+ [source.gentoo]
+ directory = "${ECARGO_VENDOR}"
+
+ [source.crates-io]
+ replace-with = "gentoo"
+ local-registry = "/nonexistant"
+
+ [net]
+ offline = true
+
+ [build]
+ jobs = $(makeopts_jobs)
+
+ [term]
+ verbose = true
+ $([[ "${NOCOLOR}" = true || "${NOCOLOR}" = yes ]] && echo "color = 'never'")
+ _EOF_
+
+ export CARGO_HOME="${ECARGO_HOME}"
+ _CARGO_GEN_CONFIG_HAS_RUN=1
+}
+
# @FUNCTION: cargo_src_unpack
# @DESCRIPTION:
# Unpacks the package and the cargo registry
@@ -122,50 +189,83 @@ cargo_live_src_unpack() {
[[ "${EBUILD_PHASE}" == unpack ]] || die "${FUNCNAME} only allowed in src_unpack"
mkdir -p "${S}" || die
+ mkdir -p "${ECARGO_VENDOR}" || die
+ mkdir -p "${ECARGO_HOME}" || die
+
+ local distdir=${PORTAGE_ACTUAL_DISTDIR:-${DISTDIR}}
+ : ${ECARGO_REGISTRY_DIR:=${distdir}/cargo-registry}
+
+ local offline="${ECARGO_OFFLINE:-${EVCS_OFFLINE}}"
+
+ if [[ ! -d ${ECARGO_REGISTRY_DIR} && ! ${offline} ]]; then
+ (
+ addwrite "${ECARGO_REGISTRY_DIR}"
+ mkdir -p "${ECARGO_REGISTRY_DIR}"
+ ) || die "Unable to create ${ECARGO_REGISTRY_DIR}"
+ fi
+
+ if [[ ${offline} ]]; then
+ local subdir
+ for subdir in cache index src; do
+ if [[ ! -d ${ECARGO_REGISTRY_DIR}/registry/${subdir} ]]; then
+ eerror "Networking activity has been disabled via ECARGO_OFFLINE or EVCS_OFFLINE"
+ eerror "However, no valid cargo registry available at ${ECARGO_REGISTRY_DIR}"
+ die "Unable to proceed with ECARGO_OFFLINE/EVCS_OFFLINE."
+ fi
+ done
+ fi
+
+ if [[ ${EVCS_UMASK} ]]; then
+ local saved_umask=$(umask)
+ umask "${EVCS_UMASK}" || die "Bad options to umask: ${EVCS_UMASK}"
+ fi
pushd "${S}" > /dev/null || die
- # need to specify CARGO_HOME before cargo_gen_config fired
- CARGO_HOME="${ECARGO_HOME}" cargo fetch || die
- CARGO_HOME="${ECARGO_HOME}" cargo vendor "${ECARGO_VENDOR}" || die
- popd > /dev/null || die
- cargo_gen_config
-}
+ # Respect user settings befire cargo_gen_config is called.
+ if [[ ! ${CARGO_TERM_COLOR} ]]; then
+ [[ "${NOCOLOR}" = true || "${NOCOLOR}" = yes ]] && export CARGO_TERM_COLOR=never
+ local unset_color=true
+ fi
+ if [[ ! ${CARGO_TERM_VERBOSE} ]]; then
+ export CARGO_TERM_VERBOSE=true
+ local unset_verbose=true
+ fi
-# @FUNCTION: cargo_gen_config
-# @DESCRIPTION:
-# Generate the $CARGO_HOME/config necessary to use our local registry and settings.
-# Cargo can also be configured through environment variables in addition to the TOML syntax below.
-# For each configuration key below of the form foo.bar the environment variable CARGO_FOO_BAR
-# can also be used to define the value.
-# Environment variables will take precedent over TOML configuration,
-# and currently only integer, boolean, and string keys are supported.
-# For example the build.jobs key can also be defined by CARGO_BUILD_JOBS.
-# Or setting CARGO_TERM_VERBOSE=false in make.conf will make build quieter.
-cargo_gen_config() {
- debug-print-function ${FUNCNAME} "$@"
+ # Let cargo fetch to system-wide location.
+ # It will keep directory organized by itself.
+ addwrite "${ECARGO_REGISTRY_DIR}"
+ export CARGO_HOME="${ECARGO_REGISTRY_DIR}"
- cat <<- EOF > "${ECARGO_HOME}/config"
- [source.gentoo]
- directory = "${ECARGO_VENDOR}"
+ # Absence of quotes around offline arg is intentional, as cargo bails out if it encounters ''
+ einfo "cargo fetch ${offline:+--offline}"
+ cargo fetch ${offline:+--offline} || die #nowarn
- [source.crates-io]
- replace-with = "gentoo"
- local-registry = "/nonexistant"
+ # Let cargo copy all required crates to "${WORKDIR}" for offline use in later phases.
+ einfo "cargo vendor ${offline:+--offline} ${ECARGO_VENDOR}"
+ cargo vendor ${offline:+--offline} "${ECARGO_VENDOR}" || die #nowarn
- [net]
- offline = true
+ # Users may have git checkouts made by cargo.
+ # While cargo vendors the sources, it still needs git checkout to be present.
+ # Copying full dir is an overkill, so just symlink it.
+ if [[ -d ${ECARGO_REGISTRY_DIR}/git ]]; then
+ ln -sv "${ECARGO_REGISTRY_DIR}/git" "${ECARGO_HOME}/git" || die
+ fi
- [build]
- jobs = $(makeopts_jobs)
+ popd > /dev/null || die
- [term]
- verbose = true
- EOF
- # honor NOCOLOR setting
- [[ "${NOCOLOR}" = true || "${NOCOLOR}" = yes ]] && echo "color = 'never'" >> "${ECARGO_HOME}/config"
+ # Restore settings if needed.
+ [[ ${unset_color} ]] && unset CARGO_TERM_COLOR
+ [[ ${unset_verbose} ]] && unset CARGO_TERM_VERBOSE
+ if [[ ${saved_umask} ]]; then
+ umask "${saved_umask}" || die
+ fi
- export CARGO_HOME="${ECARGO_HOME}"
+ # After following calls, cargo will no longer use ${ECARGO_REGISTRY_DIR} as CARGO_HOME
+ # It will be forced into offline mode to prevent network access.
+ # But since we already vendored crates and symlinked git, it has all it needs to build.
+ unset CARGO_HOME
+ cargo_gen_config
}
# @FUNCTION: cargo_src_configure
@@ -222,6 +322,9 @@ cargo_src_configure() {
cargo_src_compile() {
debug-print-function ${FUNCNAME} "$@"
+ [[ ${_CARGO_GEN_CONFIG_HAS_RUN} ]] || \
+ die "FATAL: please call cargo_gen_config before using ${FUNCNAME}"
+
tc-export AR CC CXX
set -- cargo build $(usex debug "" --release) ${ECARGO_ARGS[@]} "$@"
@@ -239,6 +342,9 @@ cargo_src_compile() {
cargo_src_install() {
debug-print-function ${FUNCNAME} "$@"
+ [[ ${_CARGO_GEN_CONFIG_HAS_RUN} ]] || \
+ die "FATAL: please call cargo_gen_config before using ${FUNCNAME}"
+
set -- cargo install $(has --path ${@} || echo --path ./) \
--root "${ED}/usr" \
$(usex debug --debug "") \
@@ -258,6 +364,9 @@ cargo_src_install() {
cargo_src_test() {
debug-print-function ${FUNCNAME} "$@"
+ [[ ${_CARGO_GEN_CONFIG_HAS_RUN} ]] || \
+ die "FATAL: please call cargo_gen_config before using ${FUNCNAME}"
+
set -- cargo test $(usex debug "" --release) ${ECARGO_ARGS[@]} "$@"
einfo "${@}"
"${@}" || die "cargo test failed"
diff --git a/eclass/cmake.eclass b/eclass/cmake.eclass
index ddee554d429f..62fa02715700 100644
--- a/eclass/cmake.eclass
+++ b/eclass/cmake.eclass
@@ -292,7 +292,7 @@ _cmake_modify-cmakelists() {
# NOTE Append some useful summary here
cat >> "${CMAKE_USE_DIR}"/CMakeLists.txt <<- _EOF_ || die
- MESSAGE(STATUS "<<< Gentoo configuration >>>
+ message(STATUS "<<< Gentoo configuration >>>
Build type \${CMAKE_BUILD_TYPE}
Install path \${CMAKE_INSTALL_PREFIX}
Compiler flags:
@@ -392,12 +392,12 @@ cmake_src_configure() {
local build_rules=${BUILD_DIR}/gentoo_rules.cmake
cat > "${build_rules}" <<- _EOF_ || die
- SET (CMAKE_ASM_COMPILE_OBJECT "<CMAKE_ASM_COMPILER> <DEFINES> <INCLUDES> ${CPPFLAGS} <FLAGS> -o <OBJECT> -c <SOURCE>" CACHE STRING "ASM compile command" FORCE)
- SET (CMAKE_ASM-ATT_COMPILE_OBJECT "<CMAKE_ASM-ATT_COMPILER> <DEFINES> <INCLUDES> ${CPPFLAGS} <FLAGS> -o <OBJECT> -c -x assembler <SOURCE>" CACHE STRING "ASM-ATT compile command" FORCE)
- SET (CMAKE_ASM-ATT_LINK_FLAGS "-nostdlib" CACHE STRING "ASM-ATT link flags" FORCE)
- SET (CMAKE_C_COMPILE_OBJECT "<CMAKE_C_COMPILER> <DEFINES> <INCLUDES> ${CPPFLAGS} <FLAGS> -o <OBJECT> -c <SOURCE>" CACHE STRING "C compile command" FORCE)
- SET (CMAKE_CXX_COMPILE_OBJECT "<CMAKE_CXX_COMPILER> <DEFINES> <INCLUDES> ${CPPFLAGS} <FLAGS> -o <OBJECT> -c <SOURCE>" CACHE STRING "C++ compile command" FORCE)
- SET (CMAKE_Fortran_COMPILE_OBJECT "<CMAKE_Fortran_COMPILER> <DEFINES> <INCLUDES> ${FCFLAGS} <FLAGS> -o <OBJECT> -c <SOURCE>" CACHE STRING "Fortran compile command" FORCE)
+ set(CMAKE_ASM_COMPILE_OBJECT "<CMAKE_ASM_COMPILER> <DEFINES> <INCLUDES> ${CPPFLAGS} <FLAGS> -o <OBJECT> -c <SOURCE>" CACHE STRING "ASM compile command" FORCE)
+ set(CMAKE_ASM-ATT_COMPILE_OBJECT "<CMAKE_ASM-ATT_COMPILER> <DEFINES> <INCLUDES> ${CPPFLAGS} <FLAGS> -o <OBJECT> -c -x assembler <SOURCE>" CACHE STRING "ASM-ATT compile command" FORCE)
+ set(CMAKE_ASM-ATT_LINK_FLAGS "-nostdlib" CACHE STRING "ASM-ATT link flags" FORCE)
+ set(CMAKE_C_COMPILE_OBJECT "<CMAKE_C_COMPILER> <DEFINES> <INCLUDES> ${CPPFLAGS} <FLAGS> -o <OBJECT> -c <SOURCE>" CACHE STRING "C compile command" FORCE)
+ set(CMAKE_CXX_COMPILE_OBJECT "<CMAKE_CXX_COMPILER> <DEFINES> <INCLUDES> ${CPPFLAGS} <FLAGS> -o <OBJECT> -c <SOURCE>" CACHE STRING "C++ compile command" FORCE)
+ set(CMAKE_Fortran_COMPILE_OBJECT "<CMAKE_Fortran_COMPILER> <DEFINES> <INCLUDES> ${FCFLAGS} <FLAGS> -o <OBJECT> -c <SOURCE>" CACHE STRING "Fortran compile command" FORCE)
_EOF_
local myCC=$(tc-getCC) myCXX=$(tc-getCXX) myFC=$(tc-getFC)
@@ -409,14 +409,14 @@ cmake_src_configure() {
# space separated.
local toolchain_file=${BUILD_DIR}/gentoo_toolchain.cmake
cat > ${toolchain_file} <<- _EOF_ || die
- SET (CMAKE_ASM_COMPILER "${myCC/ /;}")
- SET (CMAKE_ASM-ATT_COMPILER "${myCC/ /;}")
- SET (CMAKE_C_COMPILER "${myCC/ /;}")
- SET (CMAKE_CXX_COMPILER "${myCXX/ /;}")
- SET (CMAKE_Fortran_COMPILER "${myFC/ /;}")
- SET (CMAKE_AR $(type -P $(tc-getAR)) CACHE FILEPATH "Archive manager" FORCE)
- SET (CMAKE_RANLIB $(type -P $(tc-getRANLIB)) CACHE FILEPATH "Archive index generator" FORCE)
- SET (CMAKE_SYSTEM_PROCESSOR "${CHOST%%-*}")
+ set(CMAKE_ASM_COMPILER "${myCC/ /;}")
+ set(CMAKE_ASM-ATT_COMPILER "${myCC/ /;}")
+ set(CMAKE_C_COMPILER "${myCC/ /;}")
+ set(CMAKE_CXX_COMPILER "${myCXX/ /;}")
+ set(CMAKE_Fortran_COMPILER "${myFC/ /;}")
+ set(CMAKE_AR $(type -P $(tc-getAR)) CACHE FILEPATH "Archive manager" FORCE)
+ set(CMAKE_RANLIB $(type -P $(tc-getRANLIB)) CACHE FILEPATH "Archive index generator" FORCE)
+ set(CMAKE_SYSTEM_PROCESSOR "${CHOST%%-*}")
_EOF_
# We are using the C compiler for assembly by default.
@@ -432,24 +432,24 @@ cmake_src_configure() {
Winnt)
sysname="Windows"
cat >> "${toolchain_file}" <<- _EOF_ || die
- SET (CMAKE_RC_COMPILER $(tc-getRC))
+ set(CMAKE_RC_COMPILER $(tc-getRC))
_EOF_
;;
*) sysname="${KERNEL}" ;;
esac
cat >> "${toolchain_file}" <<- _EOF_ || die
- SET (CMAKE_SYSTEM_NAME "${sysname}")
+ set(CMAKE_SYSTEM_NAME "${sysname}")
_EOF_
if [ "${SYSROOT:-/}" != "/" ] ; then
# When cross-compiling with a sysroot (e.g. with crossdev's emerge wrappers)
# we need to tell cmake to use libs/headers from the sysroot but programs from / only.
cat >> "${toolchain_file}" <<- _EOF_ || die
- SET (CMAKE_FIND_ROOT_PATH "${SYSROOT}")
- SET (CMAKE_FIND_ROOT_PATH_MODE_PROGRAM NEVER)
- SET (CMAKE_FIND_ROOT_PATH_MODE_LIBRARY ONLY)
- SET (CMAKE_FIND_ROOT_PATH_MODE_INCLUDE ONLY)
+ set(CMAKE_FIND_ROOT_PATH "${SYSROOT}")
+ set(CMAKE_FIND_ROOT_PATH_MODE_PROGRAM NEVER)
+ set(CMAKE_FIND_ROOT_PATH_MODE_LIBRARY ONLY)
+ set(CMAKE_FIND_ROOT_PATH_MODE_INCLUDE ONLY)
_EOF_
fi
fi
@@ -458,20 +458,16 @@ cmake_src_configure() {
cat >> "${build_rules}" <<- _EOF_ || die
# in Prefix we need rpath and must ensure cmake gets our default linker path
# right ... except for Darwin hosts
- IF (NOT APPLE)
- SET (CMAKE_SKIP_RPATH OFF CACHE BOOL "" FORCE)
- SET (CMAKE_PLATFORM_REQUIRED_RUNTIME_PATH "${EPREFIX}/usr/${CHOST}/lib/gcc;${EPREFIX}/usr/${CHOST}/lib;${EPREFIX}/usr/$(get_libdir);${EPREFIX}/$(get_libdir)"
- CACHE STRING "" FORCE)
-
- ELSE ()
-
- SET (CMAKE_PREFIX_PATH "${EPREFIX}/usr" CACHE STRING "" FORCE)
- SET (CMAKE_MACOSX_RPATH ON CACHE BOOL "" FORCE)
- SET (CMAKE_SKIP_BUILD_RPATH OFF CACHE BOOL "" FORCE)
- SET (CMAKE_SKIP_RPATH OFF CACHE BOOL "" FORCE)
- SET (CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE CACHE BOOL "" FORCE)
-
- ENDIF (NOT APPLE)
+ if(NOT APPLE)
+ set(CMAKE_SKIP_RPATH OFF CACHE BOOL "" FORCE)
+ set(CMAKE_PLATFORM_REQUIRED_RUNTIME_PATH "${EPREFIX}/usr/${CHOST}/lib/gcc;${EPREFIX}/usr/${CHOST}/lib;${EPREFIX}/usr/$(get_libdir);${EPREFIX}/$(get_libdir)" CACHE STRING "" FORCE)
+ else()
+ set(CMAKE_PREFIX_PATH "${EPREFIX}/usr" CACHE STRING "" FORCE)
+ set(CMAKE_MACOSX_RPATH ON CACHE BOOL "" FORCE)
+ set(CMAKE_SKIP_BUILD_RPATH OFF CACHE BOOL "" FORCE)
+ set(CMAKE_SKIP_RPATH OFF CACHE BOOL "" FORCE)
+ set(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE CACHE BOOL "" FORCE)
+ endif()
_EOF_
fi
@@ -479,41 +475,41 @@ cmake_src_configure() {
local common_config=${BUILD_DIR}/gentoo_common_config.cmake
local libdir=$(get_libdir)
cat > "${common_config}" <<- _EOF_ || die
- SET (CMAKE_GENTOO_BUILD ON CACHE BOOL "Indicate Gentoo package build")
- SET (LIB_SUFFIX ${libdir/lib} CACHE STRING "library path suffix" FORCE)
- SET (CMAKE_INSTALL_LIBDIR ${libdir} CACHE PATH "Output directory for libraries")
- SET (CMAKE_INSTALL_INFODIR "${EPREFIX}/usr/share/info" CACHE PATH "")
- SET (CMAKE_INSTALL_MANDIR "${EPREFIX}/usr/share/man" CACHE PATH "")
- SET (CMAKE_USER_MAKE_RULES_OVERRIDE "${build_rules}" CACHE FILEPATH "Gentoo override rules")
- SET (CMAKE_INSTALL_DOCDIR "${EPREFIX}/usr/share/doc/${PF}" CACHE PATH "")
- SET (BUILD_SHARED_LIBS ON CACHE BOOL "")
+ set(CMAKE_GENTOO_BUILD ON CACHE BOOL "Indicate Gentoo package build")
+ set(LIB_SUFFIX ${libdir/lib} CACHE STRING "library path suffix" FORCE)
+ set(CMAKE_INSTALL_LIBDIR ${libdir} CACHE PATH "Output directory for libraries")
+ set(CMAKE_INSTALL_INFODIR "${EPREFIX}/usr/share/info" CACHE PATH "")
+ set(CMAKE_INSTALL_MANDIR "${EPREFIX}/usr/share/man" CACHE PATH "")
+ set(CMAKE_USER_MAKE_RULES_OVERRIDE "${build_rules}" CACHE FILEPATH "Gentoo override rules")
+ set(CMAKE_INSTALL_DOCDIR "${EPREFIX}/usr/share/doc/${PF}" CACHE PATH "")
+ set(BUILD_SHARED_LIBS ON CACHE BOOL "")
_EOF_
if [[ -n ${_ECM_ECLASS} ]]; then
- echo 'SET (ECM_DISABLE_QMLPLUGINDUMP ON CACHE BOOL "")' >> "${common_config}" || die
+ echo 'set(ECM_DISABLE_QMLPLUGINDUMP ON CACHE BOOL "")' >> "${common_config}" || die
fi
# See bug 689410
if [[ "${ARCH}" == riscv ]]; then
- echo 'SET (CMAKE_FIND_LIBRARY_CUSTOM_LIB_SUFFIX '"${libdir#lib}"' CACHE STRING "library search suffix" FORCE)' >> "${common_config}" || die
+ echo 'set(CMAKE_FIND_LIBRARY_CUSTOM_LIB_SUFFIX '"${libdir#lib}"' CACHE STRING "library search suffix" FORCE)' >> "${common_config}" || die
fi
if [[ "${NOCOLOR}" = true || "${NOCOLOR}" = yes ]]; then
- echo 'SET (CMAKE_COLOR_MAKEFILE OFF CACHE BOOL "pretty colors during make" FORCE)' >> "${common_config}" || die
+ echo 'set(CMAKE_COLOR_MAKEFILE OFF CACHE BOOL "pretty colors during make" FORCE)' >> "${common_config}" || die
fi
# Wipe the default optimization flags out of CMake
if [[ ${CMAKE_BUILD_TYPE} != Gentoo ]]; then
cat >> ${common_config} <<- _EOF_ || die
- SET (CMAKE_ASM_FLAGS_${CMAKE_BUILD_TYPE^^} "" CACHE STRING "")
- SET (CMAKE_ASM-ATT_FLAGS_${CMAKE_BUILD_TYPE^^} "" CACHE STRING "")
- SET (CMAKE_C_FLAGS_${CMAKE_BUILD_TYPE^^} "" CACHE STRING "")
- SET (CMAKE_CXX_FLAGS_${CMAKE_BUILD_TYPE^^} "" CACHE STRING "")
- SET (CMAKE_Fortran_FLAGS_${CMAKE_BUILD_TYPE^^} "" CACHE STRING "")
- SET (CMAKE_EXE_LINKER_FLAGS_${CMAKE_BUILD_TYPE^^} "" CACHE STRING "")
- SET (CMAKE_MODULE_LINKER_FLAGS_${CMAKE_BUILD_TYPE^^} "" CACHE STRING "")
- SET (CMAKE_SHARED_LINKER_FLAGS_${CMAKE_BUILD_TYPE^^} "" CACHE STRING "")
- SET (CMAKE_STATIC_LINKER_FLAGS_${CMAKE_BUILD_TYPE^^} "" CACHE STRING "")
+ set(CMAKE_ASM_FLAGS_${CMAKE_BUILD_TYPE^^} "" CACHE STRING "")
+ set(CMAKE_ASM-ATT_FLAGS_${CMAKE_BUILD_TYPE^^} "" CACHE STRING "")
+ set(CMAKE_C_FLAGS_${CMAKE_BUILD_TYPE^^} "" CACHE STRING "")
+ set(CMAKE_CXX_FLAGS_${CMAKE_BUILD_TYPE^^} "" CACHE STRING "")
+ set(CMAKE_Fortran_FLAGS_${CMAKE_BUILD_TYPE^^} "" CACHE STRING "")
+ set(CMAKE_EXE_LINKER_FLAGS_${CMAKE_BUILD_TYPE^^} "" CACHE STRING "")
+ set(CMAKE_MODULE_LINKER_FLAGS_${CMAKE_BUILD_TYPE^^} "" CACHE STRING "")
+ set(CMAKE_SHARED_LINKER_FLAGS_${CMAKE_BUILD_TYPE^^} "" CACHE STRING "")
+ set(CMAKE_STATIC_LINKER_FLAGS_${CMAKE_BUILD_TYPE^^} "" CACHE STRING "")
_EOF_
fi
diff --git a/eclass/elisp-common.eclass b/eclass/elisp-common.eclass
index e6346d43ccfb..66a3a325e673 100644
--- a/eclass/elisp-common.eclass
+++ b/eclass/elisp-common.eclass
@@ -407,9 +407,12 @@ elisp-site-file-install() {
sf="${T}/${sf}"
ebegin "Installing site initialisation file for GNU Emacs"
[[ $1 = "${sf}" ]] || cp "$1" "${sf}"
- [[ ${EAPI} == [45] ]] && grep -q "@EMACSMODULES@" "${sf}" \
- && die "${ECLASS}: Dynamic modules not supported in EAPI ${EAPI}"
- modules=${EMACSMODULES//@libdir@/$(get_libdir)}
+ if [[ ${EAPI} == [45] ]]; then
+ grep -q "@EMACSMODULES@" "${sf}" \
+ && die "${ECLASS}: Dynamic modules not supported in EAPI ${EAPI}"
+ else
+ modules=${EMACSMODULES//@libdir@/$(get_libdir)}
+ fi
sed -i -e "1{:x;/^\$/{n;bx;};/^;.*${PN}/I!s:^:${header}\n\n:;1s:^:\n:;}" \
-e "s:@SITELISP@:${EPREFIX}${SITELISP}/${my_pn}:g" \
-e "s:@SITEETC@:${EPREFIX}${SITEETC}/${my_pn}:g" \
diff --git a/eclass/mozconfig-v6.52.eclass b/eclass/mozconfig-v6.52.eclass
deleted file mode 100644
index 42e6fb030cd3..000000000000
--- a/eclass/mozconfig-v6.52.eclass
+++ /dev/null
@@ -1,391 +0,0 @@
-# Copyright 1999-2020 Gentoo Authors
-# Distributed under the terms of the GNU General Public License v2
-#
-# @ECLASS: mozconfig-v6.52.eclass
-# @MAINTAINER:
-# mozilla team <mozilla@gentoo.org>
-# @SUPPORTED_EAPIS: 5 6 7
-# @BLURB: the new mozilla common configuration eclass for FF33 and newer, v6
-# @DESCRIPTION:
-# This eclass is used in mozilla ebuilds (firefox, thunderbird, seamonkey)
-# to provide a single common place for the common mozilla engine compoments.
-#
-# The eclass provides all common dependencies as well as common use flags.
-#
-# Some use flags which may be optional in particular mozilla packages can be
-# supported through setting eclass variables.
-#
-# This eclass inherits mozconfig helper functions as defined in mozcoreconf-v3,
-# and so ebuilds inheriting this eclass do not need to inherit that.
-
-case ${EAPI} in
- 0|1|2|3|4)
- die "EAPI=${EAPI} not supported"
- ;;
- 5)
- inherit multilib
- ;;
-esac
-
-inherit flag-o-matic toolchain-funcs mozcoreconf-v5
-
-# @ECLASS-VARIABLE: MOZCONFIG_OPTIONAL_WIFI
-# @DEFAULT_UNSET
-# @DESCRIPTION:
-# Set this variable before the inherit line, when an ebuild needs to provide
-# optional necko-wifi support via IUSE="wifi". Currently this would include
-# ebuilds for firefox, and potentially seamonkey.
-#
-# Leave the variable UNSET if necko-wifi support should not be available.
-# Set the variable to "enabled" if the use flag should be enabled by default.
-# Set the variable to any value if the use flag should exist but not be default-enabled.
-
-# @ECLASS-VARIABLE: MOZCONFIG_OPTIONAL_JIT
-# @DEFAULT_UNSET
-# @DESCRIPTION:
-# Set this variable before the inherit line, when an ebuild needs to provide
-# deterministic jit support via IUSE="jit". The upstream default will be used
-# otherwise, which is generally to enable jit unless support for the platform
-# is missing.
-#
-# Set the variable to "enabled" if the use flag should be enabled by default.
-# Set the variable to any value if the use flag should exist but not be default-enabled.
-
-# @ECLASS-VARIABLE: MOZCONFIG_OPTIONAL_GTK3
-# @DEFAULT_UNSET
-# @DESCRIPTION:
-# Set this variable before the inherit line, when an ebuild can provide
-# optional gtk3 support via IUSE="force-gtk3". Currently this would include
-# thunderbird and seamonkey in the future, once support is ready for testing.
-#
-# Leave the variable UNSET if gtk3 support should not be optionally available.
-# Set the variable to "enabled" if the use flag should be enabled by default.
-# Set the variable to any value if the use flag should exist but not be default-enabled.
-# If gtk+:3 is to be the standard toolkit, do not use this and instead use
-# MOZCONFIG_OPTIONAL_GTK2ONLY.
-
-# @ECLASS-VARIABLE: MOZCONFIG_OPTIONAL_GTK2ONLY
-# @DEFAULT_UNSET
-# @DESCRIPTION:
-# Set this variable before the inherit line, when an ebuild can provide
-# optional gtk2-only support via IUSE="gtk2".
-#
-# Note that this option conflicts directly with MOZCONFIG_OPTIONAL_GTK3, both
-# variables cannot be set at the same time and this variable will be ignored if
-# MOZCONFIG_OPTIONAL_GTK3 is set.
-#
-# Leave the variable UNSET if gtk2-only support should not be available.
-# Set the variable to "enabled" if the use flag should be enabled by default.
-# Set the variable to any value if the use flag should exist but not be default-enabled.
-
-# @ECLASS-VARIABLE: MOZCONFIG_OPTIONAL_QT5
-# @DEFAULT_UNSET
-# @DESCRIPTION:
-# Set this variable before the inherit line, when an ebuild can provide
-# optional qt5 support via IUSE="qt5". Currently this would include
-# ebuilds for firefox, but thunderbird and seamonkey could follow in the future.
-#
-# Leave the variable UNSET if qt5 support should not be available.
-# Set the variable to "enabled" if the use flag should be enabled by default.
-# Set the variable to any value if the use flag should exist but not be default-enabled.
-
-# use-flags common among all mozilla ebuilds
-IUSE="${IUSE} dbus debug +jemalloc neon pulseaudio selinux startup-notification system-cairo
- system-harfbuzz system-icu system-jpeg system-libevent system-sqlite system-libvpx"
-
-# some notes on deps:
-# gtk:2 minimum is technically 2.10 but gio support (enabled by default) needs 2.14
-# media-libs/mesa needs to be 10.2 or above due to a bug with flash+vdpau
-
-RDEPEND=">=app-text/hunspell-1.2:=
- dev-libs/atk
- dev-libs/expat
- >=x11-libs/cairo-1.10[X]
- >=x11-libs/gtk+-2.18:2
- x11-libs/gdk-pixbuf
- >=x11-libs/pango-1.22.0
- >=media-libs/libpng-1.6.25:0=[apng]
- >=media-libs/mesa-10.2:*
- media-libs/fontconfig
- >=media-libs/freetype-2.4.10
- kernel_linux? ( !pulseaudio? ( media-libs/alsa-lib ) )
- pulseaudio? ( || ( media-sound/pulseaudio
- >=media-sound/apulse-0.1.9 ) )
- virtual/freedesktop-icon-theme
- dbus? ( >=sys-apps/dbus-0.60
- >=dev-libs/dbus-glib-0.72 )
- startup-notification? ( >=x11-libs/startup-notification-0.8 )
- >=dev-libs/glib-2.26:2
- >=sys-libs/zlib-1.2.3
- >=virtual/libffi-3.0.10
- media-video/ffmpeg
- x11-libs/libX11
- x11-libs/libXcomposite
- x11-libs/libXdamage
- x11-libs/libXext
- x11-libs/libXfixes
- x11-libs/libXrender
- x11-libs/libXt
- system-cairo? ( >=x11-libs/cairo-1.12[X,xcb(+)] >=x11-libs/pixman-0.19.2 )
- system-icu? ( >=dev-libs/icu-58.1:= )
- system-jpeg? ( >=media-libs/libjpeg-turbo-1.2.1 )
- system-libevent? ( >=dev-libs/libevent-2.0:0=[threads] )
- system-sqlite? ( >=dev-db/sqlite-3.17.0:3[secure-delete,debug=] )
- system-libvpx? ( >=media-libs/libvpx-1.5.0:0=[postproc] )
- system-harfbuzz? ( >=media-libs/harfbuzz-1.3.3:0= >=media-gfx/graphite2-1.3.8 )
-"
-
-if [[ -n ${MOZCONFIG_OPTIONAL_GTK3} ]]; then
- MOZCONFIG_OPTIONAL_GTK2ONLY=
- if [[ ${MOZCONFIG_OPTIONAL_GTK3} = "enabled" ]]; then
- IUSE+=" +force-gtk3"
- else
- IUSE+=" force-gtk3"
- fi
- RDEPEND+=" force-gtk3? ( >=x11-libs/gtk+-3.4.0:3 )"
-elif [[ -n ${MOZCONFIG_OPTIONAL_GTK2ONLY} ]]; then
- if [[ ${MOZCONFIG_OPTIONAL_GTK2ONLY} = "enabled" ]]; then
- IUSE+=" +gtk2"
- else
- IUSE+=" gtk2"
- fi
- RDEPEND+=" !gtk2? ( >=x11-libs/gtk+-3.4.0:3 )"
-fi
-if [[ -n ${MOZCONFIG_OPTIONAL_WIFI} ]]; then
- if [[ ${MOZCONFIG_OPTIONAL_WIFI} = "enabled" ]]; then
- IUSE+=" +wifi"
- else
- IUSE+=" wifi"
- fi
- RDEPEND+="
- wifi? (
- kernel_linux? ( >=sys-apps/dbus-0.60
- >=dev-libs/dbus-glib-0.72
- net-misc/networkmanager )
- )"
-fi
-
-DEPEND="app-arch/zip
- app-arch/unzip
- >=sys-devel/binutils-2.16.1
- sys-apps/findutils
- pulseaudio? ( media-sound/pulseaudio )
- ${RDEPEND}"
-
-RDEPEND+="
- pulseaudio? ( || ( media-sound/pulseaudio
- >=media-sound/apulse-0.1.9 ) )
- selinux? ( sec-policy/selinux-mozilla )"
-
-# @FUNCTION: mozconfig_config
-# @DESCRIPTION:
-# Set common configure options for mozilla packages.
-# Call this within src_configure() phase, after mozconfig_init
-#
-# Example:
-#
-# inherit mozconfig-v6.46
-#
-# src_configure() {
-# mozconfig_init
-# mozconfig_config
-# # ... misc ebuild-unique settings via calls to
-# # ... mozconfig_{annotate,use_with,use_enable}
-# mozconfig_final
-# }
-
-mozconfig_config() {
- # Migrated from mozcoreconf-2
- mozconfig_annotate 'system_libs' \
- --with-system-zlib \
- --with-system-bz2
-
- if has bindist ${IUSE}; then
- mozconfig_use_enable !bindist official-branding
- if [[ ${PN} == firefox ]] && use bindist ; then
- mozconfig_annotate '' --with-branding=browser/branding/aurora
- fi
- fi
-
- # Enable position independent executables
- mozconfig_annotate 'enabled by Gentoo' --enable-pie
- mozconfig_use_enable debug
- mozconfig_use_enable debug tests
-
- if ! use debug ; then
- mozconfig_annotate 'disabled by Gentoo' --disable-debug-symbols
- else
- mozconfig_annotate 'enabled by Gentoo' --enable-debug-symbols
- fi
-
- mozconfig_use_enable startup-notification
-
- if [[ -n ${MOZCONFIG_OPTIONAL_WIFI} ]] ; then
- # wifi pulls in dbus so manage both here
- mozconfig_use_enable wifi necko-wifi
- if use kernel_linux && use wifi && ! use dbus; then
- echo "Enabling dbus support due to wifi request"
- mozconfig_annotate 'dbus required by necko-wifi on linux' --enable-dbus
- else
- mozconfig_use_enable dbus
- fi
- else
- mozconfig_use_enable dbus
- mozconfig_annotate 'disabled' --disable-necko-wifi
- fi
-
- if [[ -n ${MOZCONFIG_OPTIONAL_JIT} ]]; then
- mozconfig_use_enable jit ion
- fi
-
- # These are enabled by default in all mozilla applications
- mozconfig_annotate '' --with-system-nspr --with-nspr-prefix="${SYSROOT}${EPREFIX}"/usr
- mozconfig_annotate '' --with-system-nss --with-nss-prefix="${SYSROOT}${EPREFIX}"/usr
- mozconfig_annotate '' --x-includes="${SYSROOT}${EPREFIX}"/usr/include --x-libraries="${SYSROOT}${EPREFIX}"/usr/$(get_libdir)
- if use system-libevent; then
- mozconfig_annotate '' --with-system-libevent="${SYSROOT}${EPREFIX}"/usr
- fi
- mozconfig_annotate '' --prefix="${EPREFIX}"/usr
- mozconfig_annotate '' --libdir="${EPREFIX}"/usr/$(get_libdir)
- mozconfig_annotate 'Gentoo default' --enable-system-hunspell
- mozconfig_annotate '' --disable-gnomeui
- mozconfig_annotate '' --enable-gio
- mozconfig_annotate '' --disable-crashreporter
- mozconfig_annotate 'Gentoo default' --with-system-png
- mozconfig_annotate '' --enable-system-ffi
- mozconfig_annotate 'Gentoo default to honor system linker' --disable-gold
- mozconfig_annotate '' --disable-gconf
- mozconfig_annotate '' --with-intl-api
-
- # skia has no support for big-endian platforms
- if [[ $(tc-endian) == "big" ]]; then
- mozconfig_annotate 'big endian target' --disable-skia
- else
- mozconfig_annotate '' --enable-skia
- fi
-
- # default toolkit is cairo-gtk2, optional use flags can change this
- local toolkit="cairo-gtk2"
- local toolkit_comment=""
- if [[ -n ${MOZCONFIG_OPTIONAL_GTK3} ]]; then
- if use force-gtk3; then
- toolkit="cairo-gtk3"
- toolkit_comment="force-gtk3 use flag"
- fi
- fi
- if [[ -n ${MOZCONFIG_OPTIONAL_GTK2ONLY} ]]; then
- if ! use gtk2 ; then
- toolkit="cairo-gtk3"
- else
- toolkit_comment="gtk2 use flag"
- fi
- fi
- if [[ -n ${MOZCONFIG_OPTIONAL_QT5} ]]; then
- if use qt5; then
- toolkit="cairo-qt"
- toolkit_comment="qt5 use flag"
- # need to specify these vars because the qt5 versions are not found otherwise,
- # and setting --with-qtdir overrides the pkg-config include dirs
- local i
- for i in qmake moc rcc; do
- echo "export HOST_${i^^}=\"$(qt5_get_bindir)/${i}\"" \
- >> "${S}"/.mozconfig || die
- done
- echo 'unset QTDIR' >> "${S}"/.mozconfig || die
- mozconfig_annotate '+qt5' --disable-gio
- fi
- fi
- mozconfig_annotate "${toolkit_comment}" --enable-default-toolkit=${toolkit}
-
- # Use jemalloc unless libc is not glibc >= 2.4
- # at this time the minimum glibc in the tree is 2.9 so we should be safe.
- if use elibc_glibc && use jemalloc; then
- # We must force-enable jemalloc 4 via .mozconfig
- echo "export MOZ_JEMALLOC4=1" >> "${S}"/.mozconfig || die
- mozconfig_annotate '' --enable-replace-malloc
- fi
-
- # Instead of the standard --build= and --host=, mozilla uses --host instead
- # of --build, and --target intstead of --host.
- # Note, mozilla also has --build but it does not do what you think it does.
- # Set both --target and --host as mozilla uses python to guess values otherwise
- mozconfig_annotate '' --target="${CHOST}"
- mozconfig_annotate '' --host="${CBUILD:-${CHOST}}"
-
- mozconfig_use_enable pulseaudio
- # force the deprecated alsa sound code if pulseaudio is disabled
- if use kernel_linux && ! use pulseaudio ; then
- mozconfig_annotate '-pulseaudio' --enable-alsa
- fi
-
- mozconfig_use_enable system-cairo
- mozconfig_use_enable system-sqlite
- mozconfig_use_with system-jpeg
- mozconfig_use_with system-icu
- mozconfig_use_with system-libvpx
- mozconfig_use_with system-harfbuzz
- mozconfig_use_with system-harfbuzz system-graphite2
-
- # Modifications to better support ARM, bug 553364
- if use neon ; then
- mozconfig_annotate '' --with-fpu=neon
- mozconfig_annotate '' --with-thumb=yes
- mozconfig_annotate '' --with-thumb-interwork=no
- fi
- if [[ ${CHOST} == armv* ]] ; then
- mozconfig_annotate '' --with-float-abi=hard
- if ! use system-libvpx ; then
- sed -i -e "s|softfp|hard|" \
- "${S}"/media/libvpx/moz.build
- fi
- fi
-}
-
-# @FUNCTION: mozconfig_install_prefs
-# @DESCRIPTION:
-# Set preferences into the prefs.js file specified as a parameter to
-# the function. This sets both some common prefs to all mozilla
-# packages, and any prefs that may relate to the use flags administered
-# by mozconfig_config().
-#
-# Call this within src_install() phase, after copying the template
-# prefs file (if any) from ${FILESDIR}
-#
-# Example:
-#
-# inherit mozconfig-v6.46
-#
-# src_install() {
-# cp "${FILESDIR}"/gentoo-default-prefs.js \
-# "${BUILD_OBJ_DIR}/dist/bin/browser/defaults/preferences/all-gentoo.js" \
-# || die
-#
-# mozconfig_install_prefs \
-# "${BUILD_OBJ_DIR}/dist/bin/browser/defaults/preferences/all-gentoo.js"
-#
-# ...
-# }
-
-mozconfig_install_prefs() {
- local prefs_file="${1}"
-
- einfo "Adding prefs from mozconfig to ${prefs_file}"
-
- # set dictionary path, to use system hunspell
- echo "pref(\"spellchecker.dictionary_path\", \"${EPREFIX}/usr/share/myspell\");" \
- >>"${prefs_file}" || die
-
- # force the graphite pref if system-harfbuzz is enabled, since the pref cant disable it
- if use system-harfbuzz ; then
- echo "sticky_pref(\"gfx.font_rendering.graphite.enabled\",true);" \
- >>"${prefs_file}" || die
- fi
-
- # force cairo as the canvas renderer on platforms without skia support
- if [[ $(tc-endian) == "big" ]] ; then
- echo "sticky_pref(\"gfx.canvas.azure.backends\",\"cairo\");" \
- >>"${prefs_file}" || die
- echo "sticky_pref(\"gfx.content.azure.backends\",\"cairo\");" \
- >>"${prefs_file}" || die
- fi
-}
diff --git a/eclass/mozcoreconf-v4.eclass b/eclass/mozcoreconf-v4.eclass
deleted file mode 100644
index ba9a65349fd1..000000000000
--- a/eclass/mozcoreconf-v4.eclass
+++ /dev/null
@@ -1,261 +0,0 @@
-# Copyright 1999-2015 Gentoo Foundation
-# Distributed under the terms of the GNU General Public License v2
-#
-# @ECLASS: mozcoreconf-v4.eclass
-# @MAINTAINER:
-# Mozilla team <mozilla@gentoo.org>
-# @BLURB: core options and configuration functions for mozilla
-# @DESCRIPTION:
-#
-# inherit mozconfig-v6.* or above for mozilla configuration support
-
-# @ECLASS-VARIABLE: MOZILLA_FIVE_HOME
-# @DESCRIPTION:
-# This is an eclass-generated variable that defines the rpath that the mozilla
-# product will be installed in. Read-only
-
-if [[ ! ${_MOZCORECONF} ]]; then
-
-PYTHON_COMPAT=( python2_7 )
-PYTHON_REQ_USE='ncurses,sqlite,ssl,threads'
-
-inherit multilib toolchain-funcs flag-o-matic python-any-r1 versionator
-
-IUSE="${IUSE} custom-cflags custom-optimization"
-
-DEPEND="virtual/pkgconfig
- ${PYTHON_DEPS}"
-
-# @FUNCTION: mozconfig_annotate
-# @DESCRIPTION:
-# add an annotated line to .mozconfig
-#
-# Example:
-# mozconfig_annotate "building on ultrasparc" --enable-js-ultrasparc
-# => ac_add_options --enable-js-ultrasparc # building on ultrasparc
-mozconfig_annotate() {
- declare reason=$1 x ; shift
- [[ $# -gt 0 ]] || die "mozconfig_annotate missing flags for ${reason}\!"
- for x in ${*}; do
- echo "ac_add_options ${x} # ${reason}" >>.mozconfig
- done
-}
-
-# @FUNCTION: mozconfig_use_enable
-# @DESCRIPTION:
-# add a line to .mozconfig based on a USE-flag
-#
-# Example:
-# mozconfig_use_enable truetype freetype2
-# => ac_add_options --enable-freetype2 # +truetype
-mozconfig_use_enable() {
- declare flag=$(use_enable "$@")
- mozconfig_annotate "$(use $1 && echo +$1 || echo -$1)" "${flag}"
-}
-
-# @FUNCTION: mozconfig_use_with
-# @DESCRIPTION:
-# add a line to .mozconfig based on a USE-flag
-#
-# Example:
-# mozconfig_use_with kerberos gss-api /usr/$(get_libdir)
-# => ac_add_options --with-gss-api=/usr/lib # +kerberos
-mozconfig_use_with() {
- declare flag=$(use_with "$@")
- mozconfig_annotate "$(use $1 && echo +$1 || echo -$1)" "${flag}"
-}
-
-# @FUNCTION: mozconfig_use_extension
-# @DESCRIPTION:
-# enable or disable an extension based on a USE-flag
-#
-# Example:
-# mozconfig_use_extension gnome gnomevfs
-# => ac_add_options --enable-extensions=gnomevfs
-mozconfig_use_extension() {
- declare minus=$(use $1 || echo -)
- mozconfig_annotate "${minus:-+}$1" --enable-extensions=${minus}${2}
-}
-
-moz_pkgsetup() {
- # Ensure we use C locale when building
- export LANG="C"
- export LC_ALL="C"
- export LC_MESSAGES="C"
- export LC_CTYPE="C"
-
- # Ensure we use correct toolchain
- export HOST_CC="$(tc-getBUILD_CC)"
- export HOST_CXX="$(tc-getBUILD_CXX)"
- tc-export CC CXX LD PKG_CONFIG
-
- # Ensure that we have a sane build enviroment
- export MOZILLA_CLIENT=1
- export BUILD_OPT=1
- export NO_STATIC_LIB=1
- export USE_PTHREADS=1
- export ALDFLAGS=${LDFLAGS}
- # ensure MOZCONFIG is not defined
- unset MOZCONFIG
-
- # set MOZILLA_FIVE_HOME
- export MOZILLA_FIVE_HOME="/usr/$(get_libdir)/${PN}"
-
- # nested configure scripts in mozilla products generate unrecognized options
- # false positives when toplevel configure passes downwards.
- export QA_CONFIGURE_OPTIONS=".*"
-
- if [[ $(gcc-major-version) -eq 3 ]]; then
- ewarn "Unsupported compiler detected, DO NOT file bugs for"
- ewarn "outdated compilers. Bugs opened with gcc-3 will be closed"
- ewarn "invalid."
- fi
-
- python-any-r1_pkg_setup
-}
-
-# @FUNCTION: mozconfig_init
-# @DESCRIPTION:
-# Initialize mozilla configuration and populate with core settings.
-# This should be called in src_configure before any other mozconfig_* functions.
-mozconfig_init() {
- declare enable_optimize pango_version myext x
- declare XUL=$([[ ${PN} == xulrunner ]] && echo true || echo false)
- declare FF=$([[ ${PN} == firefox ]] && echo true || echo false)
- declare SM=$([[ ${PN} == seamonkey ]] && echo true || echo false)
- declare TB=$([[ ${PN} == thunderbird ]] && echo true || echo false)
-
- ####################################
- #
- # Setup the initial .mozconfig
- # See http://www.mozilla.org/build/configure-build.html
- #
- ####################################
-
- case ${PN} in
- *xulrunner)
- cp xulrunner/config/mozconfig .mozconfig \
- || die "cp xulrunner/config/mozconfig failed" ;;
- *firefox)
- cp browser/config/mozconfig .mozconfig \
- || die "cp browser/config/mozconfig failed" ;;
- seamonkey)
- # Must create the initial mozconfig to enable application
- : >.mozconfig || die "initial mozconfig creation failed"
- mozconfig_annotate "" --enable-application=suite ;;
- *thunderbird)
- # Must create the initial mozconfig to enable application
- : >.mozconfig || die "initial mozconfig creation failed"
- mozconfig_annotate "" --enable-application=mail ;;
- esac
-
- ####################################
- #
- # CFLAGS setup and ARCH support
- #
- ####################################
-
- # Set optimization level
- if [[ ${ARCH} == hppa ]]; then
- mozconfig_annotate "more than -O0 causes a segfault on hppa" --enable-optimize=-O0
- elif [[ ${ARCH} == x86 ]]; then
- mozconfig_annotate "less then -O2 causes a segfault on x86" --enable-optimize=-O2
- elif use custom-optimization || [[ ${ARCH} =~ (alpha|ia64) ]]; then
- # Set optimization level based on CFLAGS
- if is-flag -O0; then
- mozconfig_annotate "from CFLAGS" --enable-optimize=-O0
- elif [[ ${ARCH} == ppc ]] && has_version '>=sys-libs/glibc-2.8'; then
- mozconfig_annotate "more than -O1 segfaults on ppc with glibc-2.8" --enable-optimize=-O1
- elif is-flag -O4; then
- mozconfig_annotate "from CFLAGS" --enable-optimize=-O4
- elif is-flag -O3; then
- mozconfig_annotate "from CFLAGS" --enable-optimize=-O3
- elif is-flag -O1; then
- mozconfig_annotate "from CFLAGS" --enable-optimize=-O1
- elif is-flag -Os; then
- mozconfig_annotate "from CFLAGS" --enable-optimize=-Os
- else
- mozconfig_annotate "Gentoo's default optimization" --enable-optimize=-O2
- fi
- else
- # Enable Mozilla's default
- mozconfig_annotate "mozilla default" --enable-optimize
- fi
-
- # Strip optimization so it does not end up in compile string
- filter-flags '-O*'
-
- # Strip over-aggressive CFLAGS
- use custom-cflags || strip-flags
-
- # Additional ARCH support
- case "${ARCH}" in
- alpha)
- # Historically we have needed to add -fPIC manually for 64-bit.
- # Additionally, alpha should *always* build with -mieee for correct math
- # operation
- append-flags -fPIC -mieee
- ;;
-
- ia64)
- # Historically we have needed to add this manually for 64-bit
- append-flags -fPIC
- ;;
-
- ppc64)
- append-flags -fPIC -mminimal-toc
- ;;
- esac
-
- # We need to append flags for gcc-6 support
- if [[ $(gcc-major-version) -ge 6 ]]; then
- append-cxxflags -fno-delete-null-pointer-checks -fno-lifetime-dse -fno-schedule-insns2
- fi
-
- # Use the MOZILLA_FIVE_HOME for the rpath
- append-ldflags -Wl,-rpath="${MOZILLA_FIVE_HOME}",--enable-new-dtags
- # Set MOZILLA_FIVE_HOME in mozconfig
- mozconfig_annotate '' --with-default-mozilla-five-home=${MOZILLA_FIVE_HOME}
-
- ####################################
- #
- # mozconfig setup
- #
- ####################################
-
- mozconfig_annotate disable_update_strip \
- --disable-updater \
- --disable-strip \
- --disable-install-strip
-
- # jemalloc won't build with older glibc
- ! has_version ">=sys-libs/glibc-2.4" && mozconfig_annotate "we have old glibc" --disable-jemalloc
-}
-
-# @FUNCTION: mozconfig_final
-# @DESCRIPTION:
-# Display a table describing all configuration options paired
-# with reasons, then clean up extensions list.
-# This should be called in src_configure at the end of all other mozconfig_* functions.
-mozconfig_final() {
- declare ac opt hash reason
- echo
- echo "=========================================================="
- echo "Building ${PF} with the following configuration"
- grep ^ac_add_options .mozconfig | while read ac opt hash reason; do
- [[ -z ${hash} || ${hash} == \# ]] \
- || die "error reading mozconfig: ${ac} ${opt} ${hash} ${reason}"
- printf " %-30s %s\n" "${opt}" "${reason:-mozilla.org default}"
- done
- echo "=========================================================="
- echo
-
- # Resolve multiple --enable-extensions down to one
- declare exts=$(sed -n 's/^ac_add_options --enable-extensions=\([^ ]*\).*/\1/p' \
- .mozconfig | xargs)
- sed -i '/^ac_add_options --enable-extensions/d' .mozconfig
- echo "ac_add_options --enable-extensions=${exts// /,}" >> .mozconfig
-}
-
-_MOZCORECONF=1
-fi